

#include "WINGsP.h"

#include <X11/Xutil.h>





/********** data ************/


#define CHECK_BUTTON_ON_WIDTH 	16
#define CHECK_BUTTON_ON_HEIGHT 	16

static char *CHECK_BUTTON_ON[] = {
"               %",
" .............%#",
" ........... .%#",
" .......... #.%#",
" ......... #%.%#",
" ........ #%..%#",
" ... #.. #%...%#",
" ... #% #%....%#",
" ... % #%.....%#",
" ...  #%......%#",
" ... #%.......%#",
" ...#%........%#",
" .............%#",
" .............%#",
" %%%%%%%%%%%%%%#",
"%###############"};

#define CHECK_BUTTON_OFF_WIDTH 	16
#define CHECK_BUTTON_OFF_HEIGHT	16

static char *CHECK_BUTTON_OFF[] = {
"               %",
" .............%#",
" .............%#",
" .............%#",
" .............%#",
" .............%#",
" .............%#",
" .............%#",
" .............%#",
" .............%#",
" .............%#",
" .............%#",
" .............%#",
" .............%#",
" %%%%%%%%%%%%%%#",
"%###############"};

#define RADIO_BUTTON_ON_WIDTH 	15
#define RADIO_BUTTON_ON_HEIGHT	15
static char *RADIO_BUTTON_ON[] = {
".....%%%%%.....",
"...%%#####%%...",
"..%##.....%.%..",
".%#%..    .....",
".%#.        ...",
"%#..        .. ",
"%#.          . ",
"%#.          . ",
"%#.          . ",
"%#.          . ",
".%%.        . .",
".%..        . .",
"..%...    .. ..",
".... .....  ...",
".....     .....",
};

#define RADIO_BUTTON_OFF_WIDTH 	15
#define RADIO_BUTTON_OFF_HEIGHT	15
static char *RADIO_BUTTON_OFF[] = {
".....%%%%%.....",
"...%%#####%%...",
"..%##.......%..",
".%#%...........",
".%#............",
"%#............ ",
"%#............ ",
"%#............ ",
"%#............ ",
"%#............ ",
".%%.......... .",
".%........... .",
"..%......... ..",
".... .....  ...",
".....     .....",
};


static char *BUTTON_ARROW[] = {
"..............%",
"....##....#### ",
"...#.%....#... ",
"..#..%#####... ",
".#............ ",
"#............. ",
".#............ ",
"..#..          ",
"...#. .........",
"....# ........."
};

#define BUTTON_ARROW_WIDTH	15
#define BUTTON_ARROW_HEIGHT	10


static char *BUTTON_ARROW2[] = {
"               ",
"    ##    ####.",
"   # %    #   .",
"  #  %#####   .",
" #            .",
"#             .",
" #            .",
"  #  ..........",
"   # .         ",
"    #.         "
};

#define BUTTON_ARROW2_WIDTH	15
#define BUTTON_ARROW2_HEIGHT	10


static char *SCROLLER_DIMPLE[] = {
".%###.",
"%#%%%%",
"#%%...",
"#%..  ",
"#%.   ",
".%.  ."
};

#define SCROLLER_DIMPLE_WIDTH   6
#define SCROLLER_DIMPLE_HEIGHT  6


static char *SCROLLER_ARROW_UP[] = {
"....%....",
"....#....",
"...%#%...",
"...###...",
"..%###%..",
"..#####..",
".%#####%.",
".#######.",
"%#######%"
};

static char *HI_SCROLLER_ARROW_UP[] = {
"    %    ",
"    %    ",
"   %%%   ",
"   %%%   ",
"  %%%%%  ",
"  %%%%%  ",
" %%%%%%% ",
" %%%%%%% ",
"%%%%%%%%%"
};

#define SCROLLER_ARROW_UP_WIDTH   9
#define SCROLLER_ARROW_UP_HEIGHT  9


static char *SCROLLER_ARROW_DOWN[] = {
"%#######%",
".#######.",
".%#####%.",
"..#####..",
"..%###%..",
"...###...",
"...%#%...",
"....#....",
"....%...."
};

static char *HI_SCROLLER_ARROW_DOWN[] = {
"%%%%%%%%%",
" %%%%%%% ",
" %%%%%%% ",
"  %%%%%  ",
"  %%%%%  ",
"   %%%   ",
"   %%%   ",
"    %    ",
"    %    "
};

#define SCROLLER_ARROW_DOWN_WIDTH   9
#define SCROLLER_ARROW_DOWN_HEIGHT  9



static char *SCROLLER_ARROW_LEFT[] = {
"........%",
"......%##",
"....%####",
"..%######",
"%########",
"..%######",
"....%####",
"......%##",
"........%"
};

static char *HI_SCROLLER_ARROW_LEFT[] = {
"        %",
"      %%%",
"    %%%%%",
"  %%%%%%%",
"%%%%%%%%%",
"  %%%%%%%",
"    %%%%%",
"      %%%",
"        %"
};

#define SCROLLER_ARROW_LEFT_WIDTH   9
#define SCROLLER_ARROW_LEFT_HEIGHT  9


static char *SCROLLER_ARROW_RIGHT[] = {
"%........",
"##%......",
"####%....",
"######%..",
"########%",
"######%..",
"####%....",
"##%......",
"%........"
};

static char *HI_SCROLLER_ARROW_RIGHT[] = {
"%        ",
"%%%      ",
"%%%%%    ",
"%%%%%%%  ",
"%%%%%%%%%",
"%%%%%%%  ",
"%%%%%    ",
"%%%      ",
"%        "
};

#define SCROLLER_ARROW_RIGHT_WIDTH   9
#define SCROLLER_ARROW_RIGHT_HEIGHT  9


static char *POPUP_INDICATOR[] = {
"        #==",
" ......%#==",
" ......%#%%",
" ......%#%%",
" %%%%%%%#%%",
"#########%%",
"==%%%%%%%%%",
"==%%%%%%%%%"
};

#define POPUP_INDICATOR_WIDTH	11
#define POPUP_INDICATOR_HEIGHT 	8



#define NORMAL_FONT "-*-helvetica-medium-r-normal-*-12-*-*-*-*-*-*-*"
#define BOLD_FONT   "-*-helvetica-bold-r-normal-*-12-*-*-*-*-*-*-*"
#define LARGE_FONT  "-*-helvetica-bold-r-normal-*-24-*-*-*-*-*-*-*"


#define LIGHT_STIPPLE_WIDTH 4
#define LIGHT_STIPPLE_HEIGHT 4
static unsigned char LIGHT_STIPPLE_BITS[] = {
   0x05, 0x0a, 0x05, 0x0a};

#define DARK_STIPPLE_WIDTH 4
#define DARK_STIPPLE_HEIGHT 4
static unsigned char DARK_STIPPLE_BITS[] = {
   0x0a, 0x04, 0x0a, 0x01};


#define STIPPLE_WIDTH 8
#define STIPPLE_HEIGHT 8
static unsigned char STIPPLE_BITS[] = {
   0x55, 0xaa, 0x55, 0xaa, 0x55, 0xaa, 0x55, 0xaa};



extern W_ViewProcedureTable _WindowViewProcedures;
extern W_ViewProcedureTable _FrameViewProcedures;
extern W_ViewProcedureTable _LabelViewProcedures;
extern W_ViewProcedureTable _ButtonViewProcedures;
extern W_ViewProcedureTable _TextFieldViewProcedures;
extern W_ViewProcedureTable _ScrollerViewProcedures;
extern W_ViewProcedureTable _ScrollViewProcedures;
extern W_ViewProcedureTable _ListViewProcedures;
extern W_ViewProcedureTable _BrowserViewProcedures;
extern W_ViewProcedureTable _PopUpButtonViewProcedures;

/*
 * All widget classes defined must have an entry here.
 */
W_ViewProcedureTable *procedureTables[16];


/*****  end data  ******/



static void
initProcedureTable()
{
    static int inited = 0;
    
    if (inited)
	return;
    inited = 1;
    
    procedureTables[WC_Window] = &_WindowViewProcedures;
    procedureTables[WC_Frame] = &_FrameViewProcedures;
    procedureTables[WC_Label] = &_LabelViewProcedures;
    procedureTables[WC_Button] = &_ButtonViewProcedures;
    procedureTables[WC_TextField] = &_TextFieldViewProcedures;
    procedureTables[WC_Scroller] = &_ScrollerViewProcedures;
/*	_ScrollViewProcedures,*/
    procedureTables[WC_List] = &_ListViewProcedures;
    procedureTables[WC_Browser] = &_BrowserViewProcedures;
    procedureTables[WC_PopUpButton] = &_PopUpButtonViewProcedures;
}


static void
renderPixmap(W_Screen *screen, Pixmap d, Pixmap mask, char **data, 
	     int width, int height)
{
    int x, y;


    if (mask)
	XSetForeground(screen->display, screen->monoGC, screen->blackPixel);
	
    for (y = 0; y < height; y++) {
	for (x = 0; x < width; x++) {
	    switch (data[y][x]) {		
	     case ' ':
	     case 'w':
		XDrawPoint(screen->display, d, screen->whiteGC, x, y);
		break;

	     case '=':
		if (mask)
		    XDrawPoint(screen->display, mask, screen->monoGC, x, y);
		       
	     case '.':
	     case 'l':
		XDrawPoint(screen->display, d, screen->lightGC, x, y);
		break;
		
	     case '%':
	     case 'd':
		XDrawPoint(screen->display, d, screen->darkGC, x, y);
		break;
		
	     case '#':
	     case 'b':
	     default:
		XDrawPoint(screen->display, d, screen->blackGC, x, y);
		break;
	    }
	}
    }
}



static WMPixmap*
makePixmap(W_Screen *sPtr, char **data, int width, int height, int masked)
{
    Pixmap pixmap, mask = None;
    
    pixmap = XCreatePixmap(sPtr->display, sPtr->rootWin, width, height, 
			   sPtr->depth);
    
    if (masked) {
	mask = XCreatePixmap(sPtr->display, sPtr->rootWin, width, height, 1);
	XSetForeground(sPtr->display, sPtr->monoGC, sPtr->whitePixel);
	XFillRectangle(sPtr->display, mask, sPtr->monoGC, 0, 0, width, height);
    }

    renderPixmap(sPtr, pixmap, mask, data, width, height);

    return WMCreatePixmapFromXPixmaps(sPtr, pixmap, mask, width, height,
				      sPtr->depth);
}

#ifdef USE_TIFF
#define WINGS_IMAGES_FILE  RESOURCE_PATH"/Images.tiff"
#else
#define WINGS_IMAGES_FILE  RESOURCE_PATH"/Images.xpm"
#endif

static Bool
loadPixmaps(WMScreen *scr)
{
    RImage *image, *tmp;
    Pixmap pixmap;
    RColor gray;
    
    image = RLoadImage(scr->rcontext, WINGS_IMAGES_FILE, 0);
    if (!image) {
	wWarning("WINGs: could not load widget images file");
	return False;
    }
    /* make it have a gray background */
    gray.red = 0xae;
    gray.green = 0xaa;
    gray.blue = 0xae;
    RCombineImageWithColor(image, &gray);
    tmp = RGetSubImage(image, 0, 0, 24, 24);
    if (!RConvertImage(scr->rcontext, tmp, &pixmap)) {
	scr->homeIcon = NULL;
    } else {
	scr->homeIcon = WMCreatePixmapFromXPixmaps(scr, pixmap, None, 24, 24,
						   scr->depth);
    }
    RDestroyImage(tmp);
    
    RDestroyImage(image);
    return True;
}


WMScreen*
WMCreateScreen(Display *display, int screen)
{    
    return WMCreateScreenWithRContext(display, screen,
				      RCreateContext(display, screen, NULL));
}


WMScreen*
WMCreateScreenWithRContext(Display *display, int screen, RContext *context)
{
    W_Screen *scrPtr;
    XColor color;
    XGCValues gcv;
    Pixmap stipple;

    initProcedureTable();
    
    scrPtr = malloc(sizeof(W_Screen));
    if (!scrPtr)
	return NULL;
    memset(scrPtr, 0, sizeof(W_Screen));
    
    scrPtr->display = display;
    scrPtr->screen = screen;

    scrPtr->depth = DefaultDepth(display, screen);

    scrPtr->visual = DefaultVisual(display, screen);
    scrPtr->lastEventTime = 0;

    scrPtr->colormap = DefaultColormap(display, screen);

    scrPtr->whitePixel = WhitePixel(display, screen);
    
    scrPtr->blackPixel = BlackPixel(display, screen);

    scrPtr->rcontext = context;
	
    if (scrPtr->depth > 1) {
	color.flags = DoRed|DoGreen|DoBlue;
    
	color.red = 0xaeba;
	color.green = 0xaaaa;
	color.blue = 0xaeba;
	if (!XAllocColor(display, scrPtr->colormap, &color)) {
	    wWarning("could not allocate light gray color");
	    scrPtr->lightPixel = scrPtr->whitePixel;
	} else {
	    scrPtr->lightPixel = color.pixel;
	}
	
	color.red = 0x5144;
	color.green = 0x5555;
	color.blue = 0x5144;
	if (!XAllocColor(display, scrPtr->colormap, &color)) {
	    wWarning("could not allocate dark gray color");
	} else {
	    scrPtr->darkPixel = scrPtr->blackPixel;
	}
	scrPtr->darkPixel = color.pixel;
    }
    
    scrPtr->rootWin = RootWindow(display, screen);

    gcv.graphics_exposures = False;
    
    gcv.function = GXcopy;
    scrPtr->copyGC = XCreateGC(display, scrPtr->rootWin, GCFunction
			       |GCGraphicsExposures, &gcv);

    scrPtr->clipGC = XCreateGC(display, scrPtr->rootWin, GCFunction
			       |GCGraphicsExposures, &gcv);

    gcv.foreground = scrPtr->whitePixel;
    scrPtr->whiteGC = XCreateGC(display, scrPtr->rootWin, GCForeground
				|GCGraphicsExposures, &gcv);

    gcv.foreground = scrPtr->blackPixel;
    scrPtr->blackGC = XCreateGC(display, scrPtr->rootWin, GCForeground
				|GCGraphicsExposures, &gcv);

    if (scrPtr->depth > 1) {
	gcv.foreground = scrPtr->lightPixel;
	scrPtr->lightGC = XCreateGC(display, scrPtr->rootWin, GCForeground
				    |GCGraphicsExposures, &gcv);

	gcv.foreground = scrPtr->darkPixel;
	scrPtr->darkGC = XCreateGC(display, scrPtr->rootWin, GCForeground
				   |GCGraphicsExposures, &gcv);
    } else {
	Pixmap lightStipple, darkStipple;
	
	lightStipple = XCreateBitmapFromData(display, scrPtr->rootWin, 
					     LIGHT_STIPPLE_BITS, 
					     LIGHT_STIPPLE_WIDTH,
					     LIGHT_STIPPLE_HEIGHT);

	darkStipple = XCreateBitmapFromData(display, scrPtr->rootWin, 
					    DARK_STIPPLE_BITS, 
					    DARK_STIPPLE_WIDTH,
					    DARK_STIPPLE_HEIGHT);
	
	gcv.foreground = scrPtr->whitePixel;
	gcv.background = scrPtr->blackPixel;
	gcv.fill_style = FillStippled;
	gcv.stipple = lightStipple;
	scrPtr->lightGC = XCreateGC(display, scrPtr->rootWin,
				    GCForeground|GCBackground|GCStipple
				    |GCFillStyle|GCGraphicsExposures, &gcv);

	gcv.foreground = scrPtr->whitePixel;
	gcv.background = scrPtr->blackPixel;
	gcv.fill_style = FillStippled;
	gcv.stipple = darkStipple;
	scrPtr->darkGC = XCreateGC(display, scrPtr->rootWin, 
				   GCForeground|GCBackground|GCStipple
				   |GCFillStyle|GCGraphicsExposures, &gcv);

	XFreePixmap(display, lightStipple);
	XFreePixmap(display, darkStipple);
    }

    
    stipple = XCreateBitmapFromData(display, scrPtr->rootWin, 
				    STIPPLE_BITS, STIPPLE_WIDTH, STIPPLE_HEIGHT);
    gcv.foreground = scrPtr->darkPixel;
    gcv.background = scrPtr->lightPixel;
    gcv.fill_style = FillStippled;
    gcv.stipple = stipple;
    scrPtr->stippleGC = XCreateGC(display, scrPtr->rootWin, 
				  GCForeground|GCBackground|GCStipple
				  |GCFillStyle|GCGraphicsExposures, &gcv);
    
    /* we need a 1bpp drawable for the monoGC, so borrow this one */
    scrPtr->monoGC = XCreateGC(display, stipple, 0, NULL);

    XFreePixmap(display, stipple);
    
    
    scrPtr->normalFont = WMLoadFont(scrPtr, NORMAL_FONT);
    gcv.font = scrPtr->normalFont->font->fid;
    gcv.foreground = scrPtr->blackPixel;
    gcv.background = scrPtr->whitePixel;
    scrPtr->normalFontGC = XCreateGC(display, scrPtr->rootWin, GCFont
				     |GCForeground|GCGraphicsExposures
				     |GCBackground, &gcv);

    scrPtr->boldFont = WMLoadFont(scrPtr, BOLD_FONT);
    gcv.font = scrPtr->boldFont->font->fid;
    gcv.foreground = scrPtr->blackPixel;
    scrPtr->boldFontGC = XCreateGC(display, scrPtr->rootWin, GCFont
				   |GCForeground|GCGraphicsExposures, &gcv);


    scrPtr->largeFont = WMLoadFont(scrPtr, LARGE_FONT);
    gcv.font = scrPtr->largeFont->font->fid;
    

    scrPtr->checkButtonImageOn = makePixmap(scrPtr, CHECK_BUTTON_ON,
					    CHECK_BUTTON_ON_WIDTH,
					    CHECK_BUTTON_ON_HEIGHT, False);

    scrPtr->checkButtonImageOff = makePixmap(scrPtr, CHECK_BUTTON_OFF,
					    CHECK_BUTTON_OFF_WIDTH,
					    CHECK_BUTTON_OFF_HEIGHT, False);

    scrPtr->radioButtonImageOn = makePixmap(scrPtr, RADIO_BUTTON_ON,
					    RADIO_BUTTON_ON_WIDTH,
					    RADIO_BUTTON_ON_HEIGHT, False);

    scrPtr->radioButtonImageOff = makePixmap(scrPtr, RADIO_BUTTON_OFF,
					    RADIO_BUTTON_OFF_WIDTH,
					    RADIO_BUTTON_OFF_HEIGHT, False);

    scrPtr->buttonArrow = makePixmap(scrPtr, BUTTON_ARROW, 
				     BUTTON_ARROW_WIDTH, BUTTON_ARROW_HEIGHT, 
				     False);

    scrPtr->pushedButtonArrow = makePixmap(scrPtr, BUTTON_ARROW2,
			           BUTTON_ARROW2_WIDTH, BUTTON_ARROW2_HEIGHT, 
				   False);


    scrPtr->scrollerDimple = makePixmap(scrPtr, SCROLLER_DIMPLE,
					SCROLLER_DIMPLE_WIDTH,
					SCROLLER_DIMPLE_HEIGHT, False);


    scrPtr->upArrow = makePixmap(scrPtr, SCROLLER_ARROW_UP,
				 SCROLLER_ARROW_UP_WIDTH,
				 SCROLLER_ARROW_UP_HEIGHT, True);

    scrPtr->downArrow = makePixmap(scrPtr, SCROLLER_ARROW_DOWN,
				   SCROLLER_ARROW_DOWN_WIDTH,
				   SCROLLER_ARROW_DOWN_HEIGHT, True);

    scrPtr->leftArrow = makePixmap(scrPtr, SCROLLER_ARROW_LEFT,
				   SCROLLER_ARROW_LEFT_WIDTH,
				   SCROLLER_ARROW_LEFT_HEIGHT, True);

    scrPtr->rightArrow = makePixmap(scrPtr, SCROLLER_ARROW_RIGHT,
				    SCROLLER_ARROW_RIGHT_WIDTH,
				    SCROLLER_ARROW_RIGHT_HEIGHT, True);

    scrPtr->hiUpArrow = makePixmap(scrPtr, HI_SCROLLER_ARROW_UP,
				 SCROLLER_ARROW_UP_WIDTH,
				 SCROLLER_ARROW_UP_HEIGHT, True);

    scrPtr->hiDownArrow = makePixmap(scrPtr, HI_SCROLLER_ARROW_DOWN,
				   SCROLLER_ARROW_DOWN_WIDTH,
				   SCROLLER_ARROW_DOWN_HEIGHT, True);

    scrPtr->hiLeftArrow = makePixmap(scrPtr, HI_SCROLLER_ARROW_LEFT,
				   SCROLLER_ARROW_LEFT_WIDTH,
				   SCROLLER_ARROW_LEFT_HEIGHT, True);

    scrPtr->hiRightArrow = makePixmap(scrPtr, HI_SCROLLER_ARROW_RIGHT,
				    SCROLLER_ARROW_RIGHT_WIDTH,
				    SCROLLER_ARROW_RIGHT_HEIGHT, True);

    scrPtr->popUpIndicator = makePixmap(scrPtr, POPUP_INDICATOR,
					POPUP_INDICATOR_WIDTH,
					POPUP_INDICATOR_HEIGHT, True);

    loadPixmaps(scrPtr);
    
    scrPtr->internalMessage = XInternAtom(display, "_WINGS_MESSAGE", False);

    
    scrPtr->rootView = W_CreateRootView(scrPtr);
    
    return scrPtr;
}


void
WMSetApplicationIcon(WMScreen *scrPtr, WMPixmap *icon)
{
    scrPtr->applicationIcon = WMRetainPixmap(icon);
}


void 
WMHangData(WMWidget *widget, void *data)
{
    W_VIEW(widget)->hangedData = data;
}


void*
WMGetHangedData(WMWidget *widget)
{
    return W_VIEW(widget)->hangedData;
}



void
WMDestroyWidget(WMWidget *widget)
{
    W_DestroyView(W_VIEW(widget));
}


void
WMSetFocusToWidget(WMWidget *widget)
{
    W_SetFocusToView(W_VIEW(widget));
}


/*
 * WMRealizeWidget-
 * 	Realizes the widget and all it's children.
 * 
 */
void
WMRealizeWidget(WMWidget *w)
{
    W_RealizeView(W_VIEW(w));
}

void
WMMapWidget(WMWidget *w)
{        
    if (!W_VIEW(w)->flags.realized) {
	W_VIEW(w)->flags.mapWhenRealized = 1;
    } else {
	W_MapView(W_VIEW(w));
    }
}


static void
makeChildrenAutomap(W_View *view)
{
    view = view->childrenList;
    
    while (view) {
	view->flags.mapWhenRealized = 1;
	makeChildrenAutomap(view);
	
	view = view->nextSister;
    }
}


void
WMMapSubwidgets(WMWidget *w)
{   
    /* make sure that subwidgets created after the parent was realized
     * are mapped too */
    makeChildrenAutomap(W_VIEW(w));
    
    W_MapSubviews(W_VIEW(w));
}

void
WMUnmapWidget(WMWidget *w)
{   
    W_UnmapView(W_VIEW(w));
}


void
WMSetWidgetBackgroundColor(WMWidget *w, WMPixel color)
{
    if (procedureTables[W_CLASS(w)]->setBackgroundColor)
	(*procedureTables[W_CLASS(w)]->setBackgroundColor)(w, color);
    else
	W_SetViewBackgroundColor(W_VIEW(w), color);
}

void
WMMoveWidget(WMWidget *w, int x, int y)
{
    if (procedureTables[W_CLASS(w)]->move)
	(*procedureTables[W_CLASS(w)]->move)(w, x, y);
    else
	W_MoveView(W_VIEW(w), x, y);
}

void
WMResizeWidget(WMWidget *w, unsigned int width, unsigned int height)
{
    if (procedureTables[W_CLASS(w)]->resize)
	(*procedureTables[W_CLASS(w)]->resize)(w, width, height);
    else
	W_ResizeView(W_VIEW(w), width, height);
}


WMEventHook*
WMHookEventHandler(WMScreen *scr, WMEventHook *handler)
{
    WMEventHook *oldHandler = scr->extraEventHandler;
    
    scr->extraEventHandler = handler;
    
    return oldHandler;
}
